// Test_call.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <iostream>

using namespace std;

// jmp instruction (with 32 bites address)
BYTE bytesJmp[] = { 0xE9 };
// call instruction (with 64 bits address)
BYTE bytesCall[] = { 0xFF, 0x15, 0x00, 0x00, 0x00, 0x00};

typedef int (* myFunction)(int param);
typedef PVOID (* TrampolineAddr)();

__declspec(noinline) int myFarFarFunction(int param)
{
	cout << "myFarFarFunction with param " << param << endl;
	return param;
}

int _tmain(int argc, _TCHAR* argv[])
{
	LONG_PTR addrFarFarFunction = (LONG_PTR)myFarFarFunction;

	LONG_PTR addrMyFunction = 0;
	TrampolineAddr addrTrampolineAddr = NULL;
	PBYTE bytesTrampoline = NULL;

	HMODULE hMod = LoadLibraryW(L"dll.dll"); // load target dll to hook myFunction
	
	if (hMod)
	{
		addrMyFunction = (LONG_PTR)GetProcAddress(hMod, "myFunction");
		addrTrampolineAddr = (TrampolineAddr)GetProcAddress(hMod, "TrampolineAddr");
		if (addrTrampolineAddr)
			bytesTrampoline = (PBYTE)(addrTrampolineAddr());
	}

	if (!addrMyFunction || !bytesTrampoline)
	{
		cout << "load target dll error." << endl;
		return 0x1ff;
	}

	((myFunction)addrMyFunction)(5); // output the result before hooked.

	DWORD dwProtect, dwOffset, dwTmp;
	BOOL bSuccess = FALSE;
	LONG lTmp;

	// jmp to the trampoline in the entry of myFuntion.
	bSuccess = VirtualProtect((LPVOID)addrMyFunction, 5, PAGE_READWRITE, &dwProtect);
	dwOffset = 0;
	memcpy((LPVOID)(addrMyFunction+dwOffset), bytesJmp, sizeof(bytesJmp));
	dwOffset += sizeof(bytesJmp);
	lTmp = (LONG)((LONG_PTR)bytesTrampoline-(addrMyFunction+dwOffset+4));
	memcpy((PVOID)(addrMyFunction+dwOffset), &lTmp, 4);
	bSuccess = VirtualProtect((LPVOID)addrMyFunction, 5, dwProtect, &dwTmp);

	// make a trampoline for myFunction & myFarFarFunction
	dwOffset = 0; 
	memcpy(bytesTrampoline+dwOffset, bytesCall, sizeof(bytesCall)); // call myFarFarFunction
	dwOffset += sizeof(bytesCall);
	memcpy(bytesTrampoline+dwOffset, &addrFarFarFunction, sizeof(addrFarFarFunction));
	dwOffset += sizeof(addrFarFarFunction);
	memcpy(bytesTrampoline+dwOffset, (PVOID)addrMyFunction, 5); // myFunction's first 5 byte instructions
	dwOffset += 5;
	memcpy(bytesTrampoline+dwOffset, bytesJmp, sizeof(bytesJmp)); // jmp myFunction
	dwOffset += sizeof(bytesJmp); 
	lTmp = (LONG)(addrMyFunction - (LONG_PTR)(bytesTrampoline+dwOffset) - 4);
	memcpy(bytesTrampoline+dwOffset, &lTmp, 4);
	bSuccess = VirtualProtect((LPVOID)bytesTrampoline, 128, PAGE_EXECUTE, &dwProtect);

	// active the hook
	((myFunction)addrMyFunction)(5); //output the result after hooked.

	// do something else
	for (int i = 0; i < 2; i++)
		cout << "do somethings else." << endl;
	
	return 0;
}

